% This program demonstrates the sailing boat with solar energy, sailing
% energy, and propulsion one.
function GUI_ASV_new()
    clear all
    
    % global variables
    global sun_az sun_el wind_ang wind_speed propeller_speed;% azimuth and elavation of the sun in I-frame, speed and angle of the wind in I-frame
    %
    global num_level lineHand_g textHand_g optLineHand_g;
    %
    global ax;% pour choisir les points
    %
    global xTar yTar xStart yStart Xpossi Ypossi;% tous les points
    
    global ptrPropeller_speed ptrWind_angle_display ptrSolar_az_display ptrSolar_el_display;
    
 %   global node_g
    
    % initial values
    num_level = 3;% the number of level in the graph
    
    sun_az = 0*pi/180;
    sun_el = 0*pi/180;
    wind_ang = 0*pi/180;
%     wind_speed = 5;
%     propeller_speed = 100;
    
        
    % main figure (la figure principal)
    
    fig2=figure(2);
    clf
    set(fig2,'position',[180 90 970 600]);
    pos = [0.31 0.12 0.6 0.8];% [left bottom width height]
%    hf = subplot('Position',pos);
    ax = axes('Position',pos);% create the Cartesian axes in the current figure and makes it the current axes
    maxX = 50;
    maxY = 50;
    ax.XLim = [0 maxX];
    ax.YLim = [0 maxY];
%    axis([0 maxX 0 maxY]);
    hold on;
    %plot(0,0);
    water = imread('NorthDirection.jpg');
    image(flipud(water),'XData',[1 10],'YData',[40 50]);
    ptrTitle=uicontrol('Style','text','string','ASV simulation','backgroundColor','y','ForegroundColor','k',...
    'Position' ,[420 570 400 20],'fontsize',16);
    %% solar field (la champ de soleil)
    ptrSolar = uicontrol('Style','text','string','Solar angles','backgroundColor','g','ForegroundColor','k',...
    'Position' ,[20 540 150 30],'fontsize',16);
    ptrSolar_azimuth = uicontrol('Style','slider','Min',-pi,'Max',pi,'Value',sun_az,'Position' ,[20 510 120 20],'fontsize',16,'Callback',@sun_Az_slide);
    
    ptrSolar_az_display = uicontrol('Style','text','string',num2str(sun_az*180/pi),'backgroundColor','m','ForegroundColor','k',...
    'Position' ,[150 510 50 20],'fontsize',16);
    
    ptrSolar_az_text = uicontrol('Style','text','string','(Deg)-Azi','backgroundColor','y','ForegroundColor','k',...
    'Position' ,[200 510 80 20],'fontsize',16);

    ptrSolar_elevation = uicontrol('Style','slider','Min',-pi,'Max',pi,'Value',sun_el,'Position' ,[20 470 120 20],'fontsize',16,'Callback',@sun_El_slide);
    
    ptrSolar_el_display = uicontrol('Style','text','string',num2str(sun_el*180/pi),'backgroundColor','m','ForegroundColor','k',...
    'Position' ,[150 470 50 20],'fontsize',16);
    
    ptrSolar_el_text = uicontrol('Style','text','string','(Deg)-Elv','backgroundColor','y','ForegroundColor','k',...
    'Position' ,[200 470 80 20],'fontsize',16);

%    ptrSolar_display = uicontrol('Style','pushbutton','string','Display','Position' ,[160 500 80 20],'fontsize',16,'Callback',@SolarDisplay);
    %% Wind field (la champ de vent)
    ptrWind = uicontrol('Style','text','string','Wind parameters','backgroundColor','g','ForegroundColor','k',...
    'Position' ,[20 420 150 30],'fontsize',16);
    
    ptrWind_speed = uicontrol('Style','popup','string',{'3','5','10'},'backgroundColor','w','ForegroundColor','k',...
    'Position' ,[20 390 120 20],'fontsize',16,'Callback',@wind_speed_change);

    ptrWind_speed_text = uicontrol('Style','text','string','Speed(m/s)','backgroundColor','y','ForegroundColor','k',...
    'Position' ,[150 390 90 20],'fontsize',16);

    ptrWind_angle = uicontrol('Style','slider','Min',0,'Max',pi,'Value',wind_ang,'Position' ,[20 350 120 20],'fontsize',16,'Callback',@wind_Angle);

    ptrWind_angle_display = uicontrol('Style','text','string',num2str(wind_ang*180/pi),'backgroundColor','m','ForegroundColor','k',...
    'Position' ,[145 350 60 20],'fontsize',16);
    
    ptrWind_angle_text = uicontrol('Style','text','string','(Deg)-Angl','backgroundColor','y','ForegroundColor','k',...
    'Position' ,[200 350 80 20],'fontsize',16);
%    ptrWind_display = uicontrol('Style','pushbutton','string','Display','Position' ,[160 400 80 20],'fontsize',16,'Callback',@WindDisplay);
    %% Propeller speed
    ptrPropeller = uicontrol('Style','text','string','Propeller speed','backgroundColor','g','ForegroundColor','k',...
    'Position' ,[20 300 150 30],'fontsize',16);

    ptrPropeller_speed = uicontrol('Style','popup','string',{'100','150','200'},'backgroundColor','w','ForegroundColor','k',...
    'Position' ,[20 270 120 20],'fontsize',16,'Callback',@propeller_speed_change);

    ptrPropeller_text = uicontrol('Style','text','string','(rad/s)','backgroundColor','y','ForegroundColor','k',...
    'Position' ,[150 270 80 20],'fontsize',16);

    %%
    ptrRun = uicontrol('Style','pushbutton','string','Run','Position' ,[550 30 120 20],'fontsize',16,'Callback',@Run_sim);
%    ptrAstar = uicontrol('Style','pushbutton','string','A* test','Position' ,[800 30 120 20],'fontsize',16,'Callback',@Astar_test);
    %% Quit program
    ptrQuit = uicontrol('Style','pushbutton','string','Quit','Position' ,[20 30 120 20],'fontsize',16,'Callback',@quitProgram);
    
    

    %% Quit function
    function quitProgram(source,event)
        close(fig2)
    end
    %% RUN function: for the first run
    function Run_sim(source,event)
    
    % prendre les values des entres
        sun_az = get(ptrSolar_azimuth,'value');
        sun_el = get(ptrSolar_elevation,'value');
        wind_speed_index = get(ptrWind_speed,'value');
        wind_speed = str2num(ptrWind_speed.String{wind_speed_index});
        wind_ang = get(ptrWind_angle,'value');
        propeller_speed_index = get(ptrPropeller_speed,'value');
        propeller_speed = str2num(ptrPropeller_speed.String{propeller_speed_index});
        
    % chosir le point de arrivé, le point de depart, les points possibles
        
        [xTar,yTar,xStart,yStart,Xpossi,Ypossi]=choosePoints();
        
    % calculer le meilleur chemin: construire la carte, chercher le
    % meilleur chemin 
        % construire le graphe et enregistrer dans node_g qui consiste à
        % parameters de environment tels que le soleil, le vente, ou le
        % courrant de la mer.
        node_g = graph_build(xStart,yStart,xTar,yTar,Xpossi,Ypossi,num_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed);% 3 is the number of levels
        
        % mise à jour le graphe avec les nouveaux nodes
        [lineHand_g,textHand_g] = graph_draw(node_g);
        % chercher le meilleur chemin
        opt_path = A_star_algo(node_g);
          
    % mise à jour le graph
        optLineHand_g = path_opt_update(opt_path);
    
      
   % 
    
    end
    %% CHANGE azimuth of the sun
    function sun_Az_slide(source,event)
        % prendre la nouvelle valeur
        sun_az = get(ptrSolar_azimuth,'value');
        % affichier la valeur
        ptrSolar_az_display.String = num2str(round(sun_az*180/pi,2));
        % recalculer le graphe
        node_g = graph_build(xStart,yStart,xTar,yTar,Xpossi,Ypossi,num_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed);% 3 is the number of levels
        % nettoyer le veille graphe
        delete(lineHand_g);
        delete(textHand_g);
        delete(optLineHand_g);
        % mise à jour le graphe avec les nouveaux nodes
        [lineHand_g,textHand_g] = graph_draw(node_g);
        % chercher le meilleur chemin
        opt_path = A_star_algo(node_g);
        % mise à jour le graphe avec le meilleur chemin
        optLineHand_g = path_opt_update(opt_path);
    end

    %% CHANGE elevation of the sun
    function sun_El_slide(source,event)
        % prendre la nouvelle valeur
        sun_el = get(ptrSolar_elevation,'value');
        % affichier la valeur
        ptrSolar_el_display.String = num2str(round(sun_el*180/pi,2));
        % recalculer le graphe
        node_g = graph_build(xStart,yStart,xTar,yTar,Xpossi,Ypossi,num_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed);% 3 is the number of levels
        % nettoyer le veille graphe
        delete(lineHand_g);
        delete(textHand_g);
        delete(optLineHand_g);
        % mise à jour le graphe avec les nouveaux nodes
        [lineHand_g,textHand_g] = graph_draw(node_g);
        % chercher le meilleur chemin
        opt_path = A_star_algo(node_g);
        % mise à jour le graphe avec le meilleur chemin
        optLineHand_g = path_opt_update(opt_path);
    end

    %% CHANGE Wind speed
    function wind_speed_change(source,event)
        % prendre la nouvelle valeur
        wind_speed_index = get(ptrWind_speed,'value');
        wind_speed = str2num(ptrWind_speed.String{wind_speed_index});
        % recalculer le graphe
        node_g = graph_build(xStart,yStart,xTar,yTar,Xpossi,Ypossi,num_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed);% 3 is the number of levels
        % nettoyer le veille graphe
        delete(lineHand_g);
        delete(textHand_g);
        delete(optLineHand_g);
        % mise à jour le graphe avec les nouveaux nodes
        [lineHand_g,textHand_g] = graph_draw(node_g);
        % chercher le meilleur chemin
        opt_path = A_star_algo(node_g);
          
        % mise à jour le graph avec le meilleur chemin
        optLineHand_g = path_opt_update(opt_path);
        
    end
    

    %% CHANGE Wind angle
    function wind_Angle(source,event)
        % prendre la nouvelle valeur de angle de vent
        wind_ang = get(ptrWind_angle,'value');
        % affichier la valeur
        ptrWind_angle_display.String = num2str(round(wind_ang*180/pi,2));
        % recalculer les nodes du graphe
        node_g = graph_build(xStart,yStart,xTar,yTar,Xpossi,Ypossi,num_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed);% 3 is the number of levels
        % nettoyer le veille graphe
        delete(lineHand_g);
        delete(textHand_g);
        delete(optLineHand_g);
        % mise à jour le graphe avec les nouveaux nodes
        [lineHand_g,textHand_g] = graph_draw(node_g);
        % chercher le meilleur chemin
        opt_path = A_star_algo(node_g);
        % mis à jour le graphe avec le meilleur chemin
        optLineHand_g = path_opt_update(opt_path);
        
    end

    %% CHANGE Propeller speed
    function propeller_speed_change(source,event)
        % prendre la nouvelle valeur
        propeller_speed_index = get(ptrPropeller_speed,'value');
        propeller_speed = str2num(ptrPropeller_speed.String{propeller_speed_index});
        % recalculer les nodes du graphe
        node_g = graph_build(xStart,yStart,xTar,yTar,Xpossi,Ypossi,num_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed);% 3 is the number of levels
        % nettoyer le veille graphe
        delete(lineHand_g);
        delete(textHand_g);
        delete(optLineHand_g);
        % mise à jour le graphe avec les nouveaux nodes
        [lineHand_g,textHand_g] = graph_draw(node_g);
        % chercher le meilleur chemin
        opt_path = A_star_algo(node_g);
        % mise à jour le graphe avec le meilleur chemin
        optLineHand_g = path_opt_update(opt_path);
        
    end
end