function [node_g]=graph_build(xStart,yStart,xTarget,yTarget,XObs,YObs,n_level,sun_az,sun_el,wind_speed,wind_ang,propeller_speed)
% construire un carte topologique: très importante
%% environment inputs
% polar plot of wind/boat:
        %% Polar plot of ASV (pseudo-data)
        theta_polar =0:15*pi/180:pi;
        %% wind zone
        % wind = 3 m/s
        v_polar_w3 = [0 0 0 3.0 4.0 4.7 5.0 4.8 4.0 3.8 3.6 3.2 3.0];
 %       h1=figure(20);
 %       set(h1,'position',[10 20 400 300]);
 %       ax = polaraxes;
 %       polarplot(theta_polar,v_polar_w3);
 %       hold on;
        % wind = 5 m/s
        v_polar_w5 = [0 0 0 2.5 3.0 4.0 4.7 4.5 3.8 3.5 3.4 2.8 2.6];
 %       polarplot(theta_polar,v_polar_w5);
        % wind = 10 m/s
        v_polar_w10 = [0 0 0 2.2 3.0 3.8 4.5 4.3 3.7 3.4 3.3 2.6 2.1];
 %       polarplot(theta_polar,v_polar_w10);
        %% dead-zone (upwind zone)
        % propeller = 100 rad/s
        v_polar_p100 = [2.8 3.0 3.8 3.9 0 0 0 0 0 0 0 0 0];
 %      polarplot(theta_polar,v_polar_p100);

        % propeller = 150 rad/s
        v_polar_p150 = [3.0 3.2 4.0 4.2 0 0 0 0 0 0 0 0 0];
 %      polarplot(theta_polar,v_polar_p150);
        % propeller = 200 rad/s
        v_polar_p200 = [3.3 3.5 4.4 4.5 0 0 0 0 0 0 0 0 0];
 %       polarplot(theta_polar,v_polar_p200);
        % plot the diagram
 %       ax.ThetaZeroLocation = 'top';
 %       ax.ThetaDir = 'clockwise'; % 90 degrees at the right
 %       title('Polar plot of ASV');
 %       legend('w=3m/s','w=5m/s','w=10m/s','propeller=100rad/s','propeller=150rad/s','propeller=200rad/s');
        %% sea current diagram: move to cost_2nodes function
%         [x,y] = meshgrid(0:5:50,0:5:50);
%         xx_sea = cos(x/25).*(y/25);
%         yy_sea = sin(x/25).*(y/25);
        %% polar plot of solar panel: t=8h; 10h; 12h; 14h;16h;18h
        phi_sun = 0:15*pi/180:pi;% angle between solar panel and sun's rays
        % t = 8h
        Ir_t8 = 3;
        PW_sun_t8 = Ir_t8*sin(phi_sun);
%         figure;
%         axx = polaraxes;
%         polarplot(phi_sun,PW_sun_t8);
%         hold on;
        % t = 10h
        Ir_t10 = 5;
        PW_sun_t10 = Ir_t10*sin(phi_sun);
%         polarplot(phi_sun,PW_sun_t10);
        % t = 12h
        Ir_t12 = 8;
        PW_sun_t12 = Ir_t12*sin(phi_sun);
%        polarplot(phi_sun,PW_sun_t12);
        % t = 14h 
        Ir_t14 = 6;
        PW_sun_t14 = Ir_t14*sin(phi_sun);
%        polarplot(phi_sun,PW_sun_t14);
        % t = 16h
        Ir_t16 = 4;
        PW_sun_t16 = Ir_t16*sin(phi_sun);
%        polarplot(phi_sun,PW_sun_t16);
        % t = 18h
        Ir_t18 = 2.5;
        PW_sun_t18 = Ir_t18*sin(phi_sun);
%        polarplot(phi_sun,PW_sun_t18);
        %
%         axx.ThetaZeroLocation = 'top';
%         axx.ThetaDir = 'clockwise'; % 90 degrees at the right
%         title('Polar plot of solar energy');
%         legend('t=8h','t=10h','t=12h','t=14h','t=16h','t=18h');
%         % interpolation
%         phi = 30*pi/180;
%         P_sun = interp1(phi_sun,PW_sun_t16,phi);
        polar_sun = PW_sun_t14;
        
        %% choose polar curves
        % wind
        if wind_speed == 3,
            v_polar_wind = v_polar_w3;
        end
        
        if wind_speed == 5,
            v_polar_wind = v_polar_w5;
        end
        
        if wind_speed == 10,
            v_polar_wind = v_polar_w10;
        end
        % propeller
        if propeller_speed == 100,
            v_polar_propeller = v_polar_p100;
        end
        
        if propeller_speed == 150,
            v_polar_propeller = v_polar_p150;
        end
        
        if propeller_speed == 200,
            v_polar_propeller = v_polar_p200;
        end




%%
% Node properties: (struct,class): build nodes

node(1).pos=[xStart yStart];
%node(1).parents = [];
%node(1).children = [];
%node(1).cost =[0 100];% adjacent cost: node <-> adjacent node; accumulated cost: initial node -> current node; estimated cost: current node -> target node
for j=1:size(XObs,2)
    node(j+1).pos=[XObs(j) YObs(j)];
%    node(j+1).parents = node(1);% ????
end
node(j+2).pos=[xTarget yTarget];
%
m = size(node,2);% the number of nodes

%% classify the nodes into levels
dis_ST = sqrt((node(1).pos(1)-node(end).pos(1)).^2 + (node(1).pos(2)-node(end).pos(2)).^2);% distance from Start point to Target point
n = n_level; % the number of levels
r = dis_ST/n; % the radius of the level

% compute distance of each node to Start node
for i=1:size(node,2)
    node(i).dis_iS = sqrt((node(i).pos(1)-node(1).pos(1)).^2 + (node(i).pos(2)-node(1).pos(2)).^2); 
end

% classify to the levels
for i=1:(n)
    level(i).node=[];
    for j=2:size(node,2)-1
        if (node(j).dis_iS/r >(i-1))&&(node(j).dis_iS/r <=i)
            level(i).node = [level(i).node node(j)];% xi of node_i = level(i).node(i).pos(1)
        end
    end
end

% rebuild all nodes for graph, build edges, other properties,donnée des soleil, vent et courant de mer;fonction de coût: g(n) et h(n)
% cout de consumption de l'energy, cout de production de l'energy, function de cout: paramètes dynamics de bateau
% Initial node: 1
node_g(1).pos = node(1).pos;
node_g(1).dis_iS = node(1).dis_iS;
node_g(1).adjNode = level(1).node;
node_g(1).edgeCost = [];% this cost will be changed w.r.t wind, solar, sea current
for i=1:size(level(1).node,2)
%     % g-function
%     %------------------
%     L_edg_ini = sqrt((node(1).pos(1)-level(1).node(i).pos(1)).^2+(node(1).pos(2)-level(1).node(i).pos(2)).^2);% distance between two nodes
%     %----------------
%     theta_edg_ini = atan2((level(1).node(i).pos(1)-node(1).pos(1)),(level(1).node(i).pos(2)-node(1).pos(2)));%angle w.r.t wind direction
%     %----------------
%     % interpolate the velocity of the boat, velocity of the sea current,
%     % output power of solar panel:
%     % calibrate the angle in feasible region
%     if (theta_edg_ini<0*pi/180)
%         theta_edg_ini = -theta_edg_ini;
%     end
%     % sailboat: interpolate between different curves
%     if (theta_edg_ini>45*pi/180)
%         v_boat_ini = interp1(theta_polar,v_polar_w3,theta_edg_ini);
%     else
%         v_boat_ini = interp1(theta_polar,v_polar_p100,theta_edg_ini);
%     end
%     
%     % sea current
%     xq_ini = (node(1).pos(1)+level(1).node(i).pos(1))/2;
%     yq_ini = (node(1).pos(2)+level(1).node(i).pos(2))/2;
%     sc_x_ini = interp2(x,y,xx_sea,xq_ini,yq_ini);
%     sc_y_ini = interp2(x,y,yy_sea,xq_ini,yq_ini);
%     v_sea_ini = sqrt(sc_x_ini.^2 + sc_y_ini.^2);
%     theta_sea_ini = atan2(sc_x_ini,sc_y_ini);
%     
%     % solar diagram
%     %----------------
%     % cost function: energy consumption and energy production
%     gg_ini = ((v_boat_ini-v_sea_ini*cos(theta_edg_ini-theta_sea_ini)).^3/v_boat_ini)*L_edg_ini;
%     %---------------------
%     % h-heuristic function: distance from current point to target point
%     hh_ini = sqrt((node(m).pos(1)-level(1).node(i).pos(1)).^2+(node(m).pos(2)-level(1).node(i).pos(2)).^2);
%     %--------------------------
%     % Total function f-function: f = wg*g + wh*h
%     wg_ini = 1;
%     wh_ini = 1;
%     f_edg_ini = wg_ini*gg_ini + wh_ini*hh_ini;
    f_edg_ini = cost_2nodes(node(1),level(1).node(i),node(m),theta_polar,v_polar_wind,v_polar_propeller,polar_sun,wind_ang,sun_az,sun_el);
    node_g(1).edgeCost = [node_g(1).edgeCost f_edg_ini];
end
% other nodes
k = 2;
while (k< m),
    for i=1:n,
        for j = 1:size(level(i).node,2)
            node_g(k).pos = level(i).node(j).pos;
            node_g(k).dis_iS = level(i).node(j).dis_iS ;
            if i==1
                node_g(k).adjNode = [node(1) level(i+1).node] ;
            else
                if i==n
                    node_g(k).adjNode = [level(i-1).node node(m)] ;
                else
                    node_g(k).adjNode = [level(i-1).node level(i+1).node] ;
                end
            end
            % edge cost
            node_g(k).edgeCost = [];% this cost will be changed w.r.t wind, solar, sea current
            for jj=1:size(node_g(k).adjNode,2) % a good way to compute edge costs
%                 xy_node = node_g(k).pos;
%                 xy_adj = node_g(k).adjNode(jj).pos;
%                 % cost function
%                 %---------------------------------
%                 L_edg = sqrt((xy_node(1)-xy_adj(1)).^2+(xy_node(2)-xy_adj(2)).^2);
%                 theta_edg = atan2(xy_node(1)-xy_adj(1),xy_node(2)-xy_adj(2));
%                 % interpolate vboat, v_seaCurrent, solar output
%                 % calibrate the angle
%                 if (theta_edg<0*pi/180)
%                     theta_edg = - theta_edg;
%                 end
%                 
%                 % sailboat: interpolate between different curves
%                 if (theta_edg>45*pi/180)
%                     v_boat = interp1(theta_polar,v_polar_w3,theta_edg);
%                 else
%                     v_boat = interp1(theta_polar,v_polar_p100,theta_edg);
%                 end
%                 % sea current
%                 xq = (xy_node(1) + xy_adj(1))/2;
%                 yq = (xy_node(2) + xy_adj(2))/2;
%                 sc_x = interp2(x,y,xx_sea,xq,yq);
%                 sc_y = interp2(x,y,yy_sea,xq,yq);
%                 v_sea = sqrt(sc_x.^2 + sc_y.^2);
%                 theta_sea = atan2(sc_x,sc_y);
%                 
%                 % solar diagram
%                 %----------------
%                 % g-cost function: energy consumption and energy production
%                 gg = ((v_boat-v_sea*cos(theta_edg-theta_sea)).^3/v_boat)*L_edg;
%                                 
%                 %---------------------
%                 % h-heuristic function: distance from current point to target point
%                 hh = sqrt((node(m).pos(1)-xy_adj(1)).^2+(node(m).pos(2)-xy_adj(2)).^2);
%                 
%                 % Total function: f-function f = wg*gg + wh*hh
%                 wg = 1;
%                 wh = 1;
%                 f_edg = wg*gg + wh*hh;
                f_edg = cost_2nodes(node_g(k),node_g(k).adjNode(jj),node(m),theta_polar,v_polar_wind,v_polar_propeller,polar_sun,wind_ang,sun_az,sun_el);
                node_g(k).edgeCost = [node_g(k).edgeCost f_edg];
            end
            
            k = k+1;
        end
     
    end
end


% Target nodes: m
node_g(m).pos = node(m).pos;
node_g(m).dis_iS = node(m).dis_iS;
node_g(m).adjNode = level(n).node;
node_g(m).edgeCost = [];
for i=1:size(level(n).node,2)
%     % cost function
%     % g-function
%     %-----------------
%     L_edg_tar = sqrt((node(m).pos(1)-level(n).node(i).pos(1)).^2+(node(m).pos(2)-level(n).node(i).pos(2)).^2);
%     theta_edg_tar = atan2(node(m).pos(1)-level(n).node(i).pos(1),node(m).pos(2)-level(n).node(i).pos(2));
%     %---------
%     % interpolate vboat, vsea, solar output
%     % calibrate the angle
%     if (theta_edg_tar<0*pi/180)
%         theta_edg_tar = -theta_edg_tar;
%     end
%     
%     % boat: interpolate between different curves
%     if (theta_edg_tar>45*pi/180)
%         v_boat_tar = interp1(theta_polar,v_polar_w3,theta_edg_tar);
%     else
%         v_boat_tar = interp1(theta_polar,v_polar_p100,theta_edg_tar);
%     end
%     % sea current
%     xq_tar = (node(m).pos(1)+level(n).node(i).pos(1))/2;
%     yq_tar = (node(m).pos(2)+level(n).node(i).pos(2))/2;
%     sc_x_tar = interp2(x,y,xx_sea,xq_tar,yq_tar);
%     sc_y_tar = interp2(x,y,yy_sea,xq_tar,yq_tar);
%     v_sea_tar = sqrt(sc_x_tar.^2 + sc_y_tar.^2);
%     theta_sea_tar = atan2(sc_x_tar,sc_y_tar);
%     % solar output
%     %----------------
%     % cost function: energy consumption and energy production
%     gg_tar = ((v_boat_tar-v_sea_tar*cos(theta_edg_tar-theta_sea_tar)).^3/v_boat_tar)*L_edg_tar;
%     %
%     % h-heuristic function: distance from current point to target point
%     hh_tar = sqrt((node(m).pos(1)-level(n).node(i).pos(1)).^2+(node(m).pos(2)-level(n).node(i).pos(2)).^2);
%     % Total function: f = wg*g + wh*h
%     wg_tar = 1;
%     wh_tar = 1;
%     f_edg_tar = wg_tar*gg_tar + wh_tar*hh_tar; 
    f_edg_tar = cost_2nodes(node(m),level(n).node(i),node(m),theta_polar,v_polar_wind,v_polar_propeller,polar_sun,wind_ang,sun_az,sun_el);
    node_g(m).edgeCost = [node_g(m).edgeCost f_edg_tar];
end
end % end function